
/* RMON-Lite interface header files */

//==========================================================================
//
//      ./agent/current/include/rmonlite_probe.h
//
//
//==========================================================================

#ifndef _MIBGROUP_RMONLITE_PROBE_H
#define _MIBGROUP_RMONLITE_PROBE_H


/* for RMON-Lite Probe access interfaces 
 *  - Defined for register to eCos SNMP generic callback mechanism.
 *  - Such callback will call to the external RMON-Lite probe(agent).
 */

#define SNMP_CALLBACK_RMONPROBE_GET         5   /* for SNMP Get/GetNext */
#define SNMP_CALLBACK_RMONPROBE_SET         6   /* for SNMP Set */


/* typedef in rmon probe */

/* the structure of parameters passed to registered RMON probe modules */
typedef struct rmonprobe_oid_value_s {
    u_char  type;  
    u_short  value_length;   /* common used for string and odi */
    u_char  *var_val;        /* pointer to the required value */
}rmonprobe_oid_value_t;

struct rmonp_snmpop_get_parameters {
    struct variable *ecos_vp;
    u_long *name;
    short  *namelen;
    int     exact;
    rmonprobe_oid_value_t **oid_val;
    int     *snmp_status;    /* to handle the SNMP status */
    int     *rmonp_status;   /* to handle the MDB processed status(True/False)*/
};

struct rmonp_snmpop_set_parameters {
    int     action;
    u_long *name;
    short  *namelen;
    rmonprobe_oid_value_t *oid_val;
    int     *snmp_status;    /* to handle the SNMP status */
    int     *rmonp_status;   /* to handle the MDB processed status(True/False)*/
};

/* ------ definition for RMON probe interface ------ */

/* The action flag from eCos SNMP Set action parameter */
#define SNMP_ACT_RESERVE1       0
#define SNMP_ACT_RESERVE2       1
#define SNMP_ACT_ACTION         2
#define SNMP_ACT_COMMIT         3
#define SNMP_ACT_FREE           4
#define SNMP_ACT_UNDO           5

#define SNMP_ACT_ROW_PROCESS    6
#define SNMP_ACT_GET_VAR        7       /* not used by SNMP actually */


/*================ RMON Probe Interface Module reference ================*/

#endif /* _MIBGROUP_RMONLITE_PROBE_H */
